VERSION 5.00
Begin VB.Form frmExCom 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "TM-D700 Normal/SUNSAT APRS"
   ClientHeight    =   3435
   ClientLeft      =   3810
   ClientTop       =   2985
   ClientWidth     =   4830
   Icon            =   "frmExCom.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3435
   ScaleWidth      =   4830
   Begin VB.CommandButton cmdSunSat 
      Caption         =   "&APRS via SUNSAT"
      Height          =   495
      Left            =   2700
      TabIndex        =   3
      Top             =   2820
      Width           =   1995
   End
   Begin VB.TextBox txtStatus 
      BackColor       =   &H8000000F&
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   180
      Locked          =   -1  'True
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   2340
      Width           =   4515
   End
   Begin VB.TextBox txtMon 
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2055
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   120
      Width           =   4575
   End
   Begin VB.CommandButton cmdNormal 
      Caption         =   "&Normal APRS Operation"
      Height          =   495
      Left            =   180
      TabIndex        =   0
      Top             =   2820
      Width           =   1995
   End
   Begin VB.Menu mnuSetup 
      Caption         =   "&Setup"
   End
   Begin VB.Menu mnuExit 
      Caption         =   "E&xit"
   End
End
Attribute VB_Name = "frmExCom"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const SETUP_SECTION = "SETUP"

Private WithEvents mcUip As clsUIVComPort
Attribute mcUip.VB_VarHelpID = -1
Private Declare Function GetTickCount Lib "kernel32" () As Long

Dim mblnResponseAwaited As Boolean
Dim mstrResponse() As String
Dim mstrResponseBuffer As String
Dim mstrLastResponse As String
Dim mblnBusy  As Boolean
Dim mstrTxFreq(1) As String
Dim mstrRxFreq(1) As String
Dim mstrTxStep(1) As String
Dim mstrRxStep(1) As String
Dim mstrBaud(1) As Integer
Dim mstrMode(1) As String
Dim mstrIniName As String

Private Function ConvertStep(strStep As String) As String
Dim strA As String

strA = "0"

Select Case strStep
    Case "5"
        strA = "0"
    Case "6.25"
        strA = "1"
    Case "10"
        strA = "2"
    Case "12.5"
        strA = "3"
    Case "15"
        strA = "4"
    Case "20"
        strA = "5"
    Case "25"
        strA = "6"
    Case "30"
        strA = "7"
    Case "50"
        strA = "8"
    Case "100"
        strA = "9"
End Select

ConvertStep = strA

End Function

Public Property Let strBaud(intIndex As Integer, strB As String)

mstrBaud(intIndex) = strB
WritePrivProfString mstrIniName, SETUP_SECTION, "BAUD_" & mstrMode(intIndex), strB

End Property

Private Sub LoadIni()
Dim strA As String
Dim intI As Integer

strA = Space$(2)
intI = GetProfileString("Intl", "sDecimal", ".", strA, Len(strA))
gstrDecimal = Left$(strA, intI)

strA = "144" & gstrDecimal & "800"
mstrTxFreq(APRS_NORMAL) = GetIniStringWriteDefault(mstrIniName, SETUP_SECTION, "TX_FREQ_NORMAL", strA)
mstrRxFreq(APRS_NORMAL) = GetIniStringWriteDefault(mstrIniName, SETUP_SECTION, "RX_FREQ_NORMAL", strA)
mstrTxStep(APRS_NORMAL) = GetIniStringWriteDefault(mstrIniName, SETUP_SECTION, "TX_STEP_NORMAL", "25")
mstrRxStep(APRS_NORMAL) = GetIniStringWriteDefault(mstrIniName, SETUP_SECTION, "RX_STEP_NORMAL", "25")
strA = "145" & gstrDecimal & "825"
mstrTxFreq(APRS_SUNSAT) = GetIniStringWriteDefault(mstrIniName, SETUP_SECTION, "TX_FREQ_SUNSAT", strA)
strA = "436" & gstrDecimal & "250"
mstrRxFreq(APRS_SUNSAT) = GetIniStringWriteDefault(mstrIniName, SETUP_SECTION, "RX_FREQ_SUNSAT", strA)
mstrTxStep(APRS_SUNSAT) = GetIniStringWriteDefault(mstrIniName, SETUP_SECTION, "TX_STEP_SUNSAT", "5")
mstrRxStep(APRS_SUNSAT) = GetIniStringWriteDefault(mstrIniName, SETUP_SECTION, "RX_STEP_SUNSAT", "5")
mstrBaud(APRS_NORMAL) = GetIniStringWriteDefault(mstrIniName, SETUP_SECTION, "BAUD_NORMAL", "1200")
mstrBaud(APRS_SUNSAT) = GetIniStringWriteDefault(mstrIniName, SETUP_SECTION, "BAUD_SUNSAT", "9600")

End Sub

Private Function GetComPort() As Long
Dim intCount As Integer
Dim lngT As Long

lngT = mcUip.RequestComPort()

'Retry up to 10 times.
Do While lngT <= PORT_UNAVAILABLE And intCount < 10
    If lngT = PORT_CLOSED Or lngT = PORT_UNAVAILABLE Then Exit Function
    intCount = intCount + 1
    MilliSecDelay 100
    lngT = mcUip.RequestComPort()
Loop

GetComPort = lngT

End Function

Private Sub ProcessRxData(strData As String)
Dim intI As Integer
Dim intJ As Integer
Dim strC As String * 1
Dim strBuff As String
Dim strA As String

For intI = 1 To Len(strData)
    strC = Mid(strData, intI, 1)
    'dump nulls and LFs.
    If strC = Chr$(0) Or strC = vbLf Then GoTo ProcRxLoopEnd

    If strC <> vbCr Then
        strBuff = strBuff & strC
    Else
        strBuff = strBuff & vbCrLf
    End If

    If mblnResponseAwaited Then
        mstrResponseBuffer = mstrResponseBuffer & strC
        'Sanity protection
        If Len(mstrResponseBuffer) > 100 Then _
            mstrResponseBuffer = Right$(mstrResponseBuffer, 50)
        
        For intJ = 1 To UBound(mstrResponse)
            strA = mstrResponse(intJ)
            If Right$(mstrResponseBuffer, Len(strA)) Like strA Then
                'Keep the response in case it's needed.
                mstrLastResponse = Right$(mstrResponseBuffer, Len(strA))
                mblnResponseAwaited = False
                Exit For
            End If
        Next intJ
    End If
ProcRxLoopEnd:
Next intI

If Len(txtMon) > 20000 Then txtMon = Right$(txtMon, 10000)
txtMon.SelStart = &H7FFF
txtMon.SelText = strBuff

End Sub

'The messing about in this function is to try and use the D700
'so the lower frequency is on the left VFO. I think that is how
'most users would normally use the rig.
Private Sub SendCommands(intMode As Integer)
Dim dblRx As Double
Dim dblTx As Double
Dim strBaud As String
Dim strA As String
Dim dblFreqA As Double
Dim dblFreqB As Double
Dim strDMode As String
Dim lngT As Long
Dim strStepIndex As String
Dim strRxStep As String
Dim strTxStep As String
Dim strStepA As String
Dim strStepB As String

txtStatus = ""

dblRx = CDbl(mstrRxFreq(intMode))
dblTx = CDbl(mstrTxFreq(intMode))
strBaud = mstrBaud(intMode)
strRxStep = mstrRxStep(intMode)
strTxStep = mstrTxStep(intMode)

If dblRx = dblTx Then
    If dblRx < 200 Then
        dblFreqA = dblRx
        strStepA = strRxStep
    Else
        dblFreqB = strA
        strStepB = strRxStep
    End If
    strDMode = "0"
Else
    If dblRx < dblTx Then
        dblFreqA = dblRx
        dblFreqB = dblTx
        strStepA = strRxStep
        strStepB = strTxStep
        strDMode = "3"
    Else
        dblFreqA = dblTx
        dblFreqB = dblRx
        strStepA = strTxStep
        strStepB = strRxStep
        strDMode = "2"
    End If
End If

lngT = GetComPort()
If lngT <= PORT_UNAVAILABLE Then Exit Sub

'Send two Ctrl+C's, because the TM-D700 sometimes
'seems to miss the first one if it's busy.
SendTNCCommand lngT, Chr$(3)
MilliSecDelay 100
SendTNCCommand lngT, Chr$(3)

'Select control mode. Don't check for a response
'because it can be mixed up with monitored traffic.
SendTNCCommand lngT, "TC 1" & vbCr
MilliSecDelay 100

If dblFreqA <> 0# Then
    'Set TX band and control band to A.
    If Not SendTNCCommand(lngT, "BC 0,0" & vbCr, "BC 0,0!N") Then
        txtStatus = "Failed BC 0,0"
        mcUip.ReleaseComPort lngT
        Exit Sub
    End If
    
    'Set the frequency.
    strStepIndex = ConvertStep(strStepA)
    strA = "FQ " & Format$(dblFreqA * 1000000, "00000000000") & "," & strStepIndex
    If Not SendTNCCommand(lngT, strA & vbCr, strA & "!N") Then
        txtStatus = "Failed FQ A"
        GoTo SetupDone
    End If
End If

If dblFreqB <> 0# Then
    'Set TX band and control band to B.
    If Not SendTNCCommand(lngT, "BC 1,1" & vbCr, "BC 1,1!N") Then
        txtStatus = "Failed BC 1,1"
        GoTo SetupDone
    End If
    
    'Set the frequency.
    strStepIndex = ConvertStep(strStepB)
    strA = "FQ " & Format$(dblFreqB * 1000000, "00000000000") & "," & strStepIndex
    If Not SendTNCCommand(lngT, strA & vbCr, strA & "!N") Then
        txtStatus = "Failed FQ B"
        GoTo SetupDone
    End If
End If

'Set data band.
strA = "DTB " & strDMode
If Not SendTNCCommand(lngT, strA & vbCr, strA & "!N") Then
    txtStatus = "Failed DTB"
    mcUip.ReleaseComPort lngT
    Exit Sub
End If

SetupDone:

'Close control mode.
If Not SendTNCCommand(lngT, "TC 0" & vbCr) Then
    txtStatus = "Failed 'TC 0'"
    mcUip.ReleaseComPort lngT
    Exit Sub
End If

'Send the HBAUD command.
If Not SendTNCCommand(lngT, "HBAUD " & strBaud & vbCr, "cmd:") Then
    txtStatus = "Failed HBAUD"
End If

'Back into converse mode.
If Not SendTNCCommand(lngT, "CONV" & vbCr) Then txtStatus = "Failed 'CONV'"

mcUip.ReleaseComPort lngT

End Sub

Public Property Let strRxStep(intIndex As Integer, strStep As String)

mstrRxStep(intIndex) = strStep
WritePrivProfString mstrIniName, SETUP_SECTION, "RX_STEP_" & mstrMode(intIndex), strStep

End Property

Public Property Let strTxStep(intIndex As Integer, strStep As String)

mstrTxStep(intIndex) = strStep
WritePrivProfString mstrIniName, SETUP_SECTION, "TX_STEP_" & mstrMode(intIndex), strStep

End Property

Private Function SendTNCCommand(lngToken As Long, strCommand As String, _
    Optional strResponse As String, Optional intWait As Integer = 1000) As Integer
Dim lngTick As Long

If strResponse <> "" Then
    mblnResponseAwaited = True
    MakeList strResponse, "!", mstrResponse()
    mstrResponseBuffer = ""
End If

If Not mcUip.SendData(lngToken, strCommand) Then
    Debug.Print "Send failed. " & strCommand
    Exit Function
End If

If strResponse <> "" Then
    lngTick = GetTickCount() + intWait
    Do While GetTickCount() < lngTick And mblnResponseAwaited
        DoEvents
    Loop
    SendTNCCommand = Not mblnResponseAwaited
    mblnResponseAwaited = False
Else
    SendTNCCommand = True
End If

End Function

Private Sub MakeList(ByVal strItems As String, strSep As String, strList() As String)
Dim intCount As Integer
Dim intI As Integer

On Error GoTo MakeListErr

ReDim strList(0)

intI = InStr(strItems, strSep)
Do While intI <> 0
    intCount = intCount + 1
    ReDim Preserve strList(intCount)
    strList(intCount) = Trim$(Left$(strItems, intI - 1))
    strItems = Trim$(Mid$(strItems, intI + 1))
    intI = InStr(strItems, strSep)
Loop

If strItems <> "" Then
    intCount = intCount + 1
    ReDim Preserve strList(intCount)
    strList(intCount) = strItems
End If

MakeListErr:
Exit Sub

End Sub

Sub MilliSecDelay(w As Integer)
Dim s As Long

s = GetTickCount() + w
Do While GetTickCount() < s
    DoEvents
Loop

End Sub

Public Property Let strRxFreq(intIndex As Integer, strFreq As String)

mstrRxFreq(intIndex) = strFreq
WritePrivProfString mstrIniName, SETUP_SECTION, "RX_FREQ_" & mstrMode(intIndex), strFreq

End Property

Public Property Let strTxFreq(intIndex As Integer, strFreq As String)

mstrTxFreq(intIndex) = strFreq
WritePrivProfString mstrIniName, SETUP_SECTION, "TX_FREQ_" & mstrMode(intIndex), strFreq

End Property

Public Property Get strRxFreq(intIndex As Integer) As String

strRxFreq = mstrRxFreq(intIndex)

End Property

Public Property Get strRxStep(intIndex As Integer) As String

strRxStep = mstrRxStep(intIndex)

End Property

Public Property Get strTxStep(intIndex As Integer) As String

strTxStep = mstrTxStep(intIndex)

End Property

Public Property Get strTxFreq(intIndex As Integer) As String

strTxFreq = mstrTxFreq(intIndex)

End Property

Public Property Get strBaud(intIndex As Integer) As String

strBaud = mstrBaud(intIndex)

End Property

Private Sub cmdNormal_Click()

If mblnBusy Then Exit Sub
mblnBusy = True
SendCommands APRS_NORMAL
mblnBusy = False

End Sub

Private Sub cmdSunSat_Click()

If mblnBusy Then Exit Sub
mblnBusy = True
SendCommands APRS_SUNSAT
mblnBusy = False

End Sub

Private Sub Form_Load()
Const MBOX_TITLE = "Fatal Error"
Dim intP As Integer
Dim strA As String
Dim blnFailed As Boolean

Height = 4125
Move (Screen.Width - Width) / 2, (Screen.Height - Height) / 2
Show
DoEvents

mstrIniName = App.Path & "\" & App.EXEName & ".INI"
mstrMode(APRS_NORMAL) = "NORMAL"
mstrMode(APRS_SUNSAT) = "SUNSAT"

LoadIni

Set mcUip = New clsUIVComPort
If mcUip.intCommsMode <> TNC_MODE Then
    MsgBox "UI-View32 isn't in TNC mode.", vbCritical, MBOX_TITLE
    blnFailed = True
End If

If Not blnFailed Then
    intP = mcUip.intPortStatus
    
    If intP = PORT_CLOSED Or intP = PORT_UNAVAILABLE Then
        MsgBox "The UI-View32 COM port is not available to external applications.", vbCritical, MBOX_TITLE
        blnFailed = True
    End If
End If

If Not blnFailed Then
    strA = UCase$(GetIniString(App.Path & "\uiview32.ini", "COMMS", "COMMAND_FILE", ""))
    If Right$(strA, 11) <> "TM-D700.CMD" Then
        MsgBox "UI-View32 isn't using the TM-D700 command file, " & _
            "so presumably it isn't being used with a TM-D700.", vbCritical, MBOX_TITLE
        blnFailed = True
    End If
End If

If Not blnFailed Then
    strA = UCase$(Command$)
    If InStr(strA, "NORMAL") <> 0 Then
        cmdNormal_Click
    ElseIf InStr(strA, "SUNSAT") <> 0 Then
        cmdSunSat_Click
    End If
Else
    cmdNormal.Enabled = False
    cmdSunSat.Enabled = False
End If

End Sub

Private Sub mcUip_ReceivedData(strData As String)

ProcessRxData strData

End Sub

Private Sub mcUip_UIView32IsClosing()

Set mcUip = Nothing
Unload Me

End Sub

Private Sub mnuExit_Click()

Unload Me

End Sub

Private Sub mnuSetup_Click()

frmSetup.Show vbModal

End Sub

